.286

code segment public 'code'
                assume  cs:code, ds:code, ss:code

                public  Disassemble

;==============================================================================
;
; Disassemble:  ds:si -> Code
;               es:di -> Buffer (48 bytes)
;
;      Return:  cx    =  Size of Instruction
;               ds:si -> Saved
;               es:di -> filled (ASCIIZ)
;

SegOverride     db      ?
AddrOprSize     db      ?


Disassemble:    push    ax
                push    bx
                push    dx
                push    si
                push    di
                cld
                mov     bx,offset Opcodes1
                mov     cs:SegOverride,-1
                mov     cs:AddrOprSize,0
LoadOpcode:     lodsb
                mov     ah,0
                mov     dl,al
                mov     dh,ds:[si]
                xlat    cs:[bx]
CopyMnemonic:   cmp     al,22
                jae     MnemonicOK
                call    TestOprSize
                jz      MnemonicOK
                inc     ax
MnemonicOK:     cmp     al,0e0h
                jae     Special
                cmp     dl,0f0h
                jb      NoPrefix
                cmp     dl,0f4h
                jbe     NoPrefix
                pop     di
                push    di
NoPrefix:       push    si
                mov     si,offset Mnemonics
                add     ax,ax
                add     si,ax
                add     ax,ax
                add     si,ax
                db      2eh
                movsw
                db      2eh
                movsw
                db      2eh
                movsw
                mov     ax,'  '
                stosw
                pop     si
                cmp     dl,0f0h
                jb      Operands
                cmp     dl,0f4h
                jb      LoadOpcode
Operands:       inc     bh
                mov     al,dl
                mov     ah,0
                add     bx,ax
                add     bx,ax
                mov     ax,dx
                call    word ptr cs:[bx]
DisasmDone:     mov     al,0
                stosb
                mov     cx,si
                pop     di
                pop     si
                sub     cx,si
                pop     dx
                pop     bx
                pop     ax
                ret

TestAddrSize:   test    cs:AddrOprSize,1
___:            ret

TestOprSize:    test    cs:AddrOprSize,2
                ret

Special:        cmp     al,0e8h
                jb      GroupOpcode
                cmp     al,0eeh
                jb      OverrideSeg
                cmp     al,0f0h
                jb      OverrideSize
                ja      InvalidOpcode
                mov     bx,offset Opcodes2
                jmp     LoadOpcode

OverrideSeg:    sub     al,0e8h
                mov     cs:SegOverride,al
                jmp     LoadOpcode

OverrideSize:   sub     al,0eeh - 1
                or      cs:AddrOprSize,al
                mov     bx,offset Opcodes1
                jmp     LoadOpcode

InvalidOpcode:  mov     ax,'??'
                stosw
                stosb
                mov     ax,'  '
                stosb
                stosw
                stosw
                jmp     Operands

GroupOpcode:    push    bx
                mov     bx,offset Opcodes3
                sub     al,0e0h
                shl     ax,3
                add     bx,ax
                mov     al,ds:[si]
                and     ax,38h
                shr     ax,3
                xlat    cs:[bx]
                pop     bx
                jmp     CopyMnemonic


_G3Eb:          call    _Eb
                test    dl,30h
                jnz     ___
                jmp     Comma_Ib

_G3Ev:          call    _Ev
                test    dl,30h
                jnz     ___
                jmp     Comma_Iv

_G4             equ     _Eb

_G5:            test    al,30h
                jpo     _G51
                jmp     _Ev
_G51:           test    al,08h
                jz      _G52
                jmp     _Mp
_G52:           jmp     _Ev

HexDWord:       push    ax
                mov     ax,cx
                call    HexWord
                pop     ax
HexWord:        push    ax
                mov     al,ah
                call    HexByte
                pop     ax
HexByte:        push    ax
                shr     al,4
                call    HexDigit
                pop     ax
HexDigit:       and     al,0fh
                add     al,'0'
                cmp     al,'9'
                jbe     DigitOK
                add     al,7
DigitOK:        stosb
                ret

Comma:          mov     byte ptr es:[di],','
                inc     di
                ret

_gs:            mov     al,4
                jmp     short _Rs
_fs:            mov     al,5
                jmp     short _Rs

Comma_Sr:       call    Comma
_Sr:            mov     al,dh
                shr     al,3
                jmp     short _Rs

_Rs18:          shr     al,3
                and     al,3
_Rs:            mov     bx,ax
                and     bx,7
                add     bx,bx
                mov     ax,word ptr cs:SegRegs[bx]
                stosw
                ret

Comma_al:       call    Comma
_al:            xor     ax,ax
                jmp     short _Rb

Comma_ax:       call    Comma
_ax:            xor     ax,ax
_Rv:            call    TestOprSize
                jz      _Rw
_Rd:            mov     byte ptr es:[di],'E'
                inc     di
_Rw:            mov     bx,ax
                and     bx,7
                add     bx,bx
                mov     ax,word ptr cs:WordRegs[bx]
                stosw
                ret

_R:             test    dl,1
                jnz     _Rv
_Rb:            mov     bx,ax
                and     bx,7
                add     bx,bx
                mov     ax,word ptr cs:ByteRegs[bx]
                stosw
                ret

_Mp:            call    TestAddrSize
                jz      _Ed
                mov     al,'F'
                stosb
                jmp     short _Ew

_Eb:            cmp     dh,0c0h
                jae     _M
                mov     ax,'YB'
                stosw
                mov     ax,'ET'
                jmp     short _ptr

_Ev:            call    TestOprSize
                jz      _Ew
_Ed:            cmp     dh,0c0h
                jae     _M
                mov     al,'D'
                stosb
_Ew:            cmp     dh,0c0h
                jae     _M
                mov     ax,'OW'
                stosw
                mov     ax,'DR'
_ptr:           stosw
                mov     ax,'P '
                stosw
                mov     ax,'RT'
                stosw
                mov     al,' '
                stosb
                jmp     _M

Comma_M:        call    Comma
_M:             mov     al,cs:SegOverride
                cmp     al,-1
                je      _M00
                call    _Rs
                mov     al,':'
                stosb
_M00:           lodsb
                cmp     al,0c0h
                jae     _R
                mov     byte ptr es:[di],'['
                inc     di
                call    TestAddrSize
                jz      _M10
                mov     ah,al
                and     ax,0c007h
                or      al,20h
                cmp     ax,25h
                je      _M05
                cmp     al,24h
                jne     _M01
                lodsb
                push    ax
                and     ax,0c007h
                cmp     ax,5
                pop     ax
                jne     _M01
                or      ah,80h
                jmp     _M02
_M01:           push    ax              ; base register
                call    _Rd
                pop     ax
                or      ah,1
_M02:           push    ax              ; test for no index
                and     al,38h
                cmp     al,20h
                pop     ax
                je      _M05
                test    ah,1
                jz      _M03
                push    ax
                mov     al,'+'
                stosb
                pop     ax
_M03:           push    ax              ; scale factor
                shr     al,6
                mov     cl,al
                mov     al,1
                shl     al,cl
                cmp     al,1
                je      _M04
                add     al,'0'
                mov     ah,'*'
                stosw
_M04:           pop     ax
                push    ax              ; index register
                shr     al,3
                call    _Rd
                pop     ax
                or      ah,1
_M05:           test    ah,1
                jz      _M06
                mov     al,'+'
                stosb
_M06:           test    ah,0c0h
                jz      _M99
                test    ah,080h
                jz      _M07
                lodsw
                xchg    ax,cx
                lodsw
                xchg    ax,cx
                jmp     _M08
_M07:           lodsb
                cbw
                cwd
_M08:           call    HexDWord
_M09:           jmp     _M99
_M10:           push    ax
                and     al,0c7h
                cmp     al,6
                pop     ax
                je      _M13
                push    ax
                and     ax,7
                mov     bx,ax
                add     bx,ax
                mov     ax,word ptr cs:FirstEAReg[bx]
                stosw
                cmp     al,4
                jae     _M11
                mov     al,'+'
                stosb
                mov     ax,word ptr cs:SecondEAReg[bx]
                stosw
_M11:           pop     ax
_M12:           test    al,0c0h
                jz      _M99
                mov     al,'+'
                stosb
                js      _M13
                lodsb
                cbw
                jmp     _M14
_M13:           lodsw
_M14:           call    HexWord
_M99:           mov     al,']'
                stosb
                ret

_aldx:          call    _al
Comma_dx:       call    Comma
_dx:            mov     ax,'XD'
                stosw
                ret

_alIb:          call    _al
                jmp     Comma_Ib

_alOb:          call    _al
                jmp     Comma_Ob

_axdx:          call    _ax
                jmp     Comma_dx

_axIb:          call    _ax
                jmp     Comma_Ib

_axOv:          call    _ax
                jmp     Comma_Ov

_axRv:          call    _ax
                call    Comma
                mov     ax,dx
                jmp     _Rv

_dxal:          call    _dx
                jmp     Comma_al

_Ibal:          call    _Ib
                jmp     Comma_al

_dxax:          call    _dx
                jmp     Comma_ax

_Ibax:          call    _Ib
                jmp     Comma_ax

_axIv:          call    _ax
                jmp     Comma_Iv

_3:             mov     al,'3'
                stosb
                ret

_Ap:            lodsw
                push    ax
                lodsw
                call    HexWord
                mov     al,':'
                stosb
                pop     ax
                jmp     HexWord

Comma_Cd:       call    Comma
_Cd:            mov     ax,'RC'
_Cd1:           stosw
                mov     al,dh
                shr     al,3
                and     al,7
                add     al,'0'
                stosb
                ret

_CdRd:          call    _Cd
                call    Comma
                jmp     _Rd

Comma_Dd:       call    Comma
_Dd:            mov     ax,'RD'
                jmp     _Cd1

_DdRd:          call    _Dd
                call    Comma
                jmp     _Rd

_Eb1:           call    _Eb
Comma_1:        call    Comma
                mov     al,'1'
                stosb
                ret

_Ebcl:          call    _Eb
Comma_cl:       call    Comma
                mov     ax,'LC'
                stosw
                ret

_EbIb:          call    _Eb
                jmp     Comma_Ib

_EbGb:          call    _M
                jmp     Comma_Gb

_Ev1:           call    _Ev
                jmp     Comma_1

_EvIb:          call    _Ev
                jmp     Comma_Ib

_Evcl:          call    _Ev
                jmp     Comma_cl

_EvGv:          call    _M
                jmp     Comma_Gv

_EvGvIb:        call    _M
                call    Comma_Gv
                jmp     Comma_Ib

_EvGvcl:        call    _M
                call    Comma_Gv
                jmp     Comma_cl

_EvIv:          call    _Ev
                jmp     Comma_Iv

_EwGw:          call    _M
                jmp     Comma_Gw

_EwSr:          mov     dl,1
                call    _M
                jmp     Comma_Sr

Comma_Gb:       call    Comma
_Gb:            mov     al,dh
                shr     al,3
                jmp     _Rb

_GbEb:          call    _Gb
                call    Comma
                jmp     _M

_GvEb:          call    _Gv
                call    Comma
                jmp     _M

Comma_Gv:       call    Comma
_Gv:            mov     al,dh
                shr     al,3
                jmp     _Rv

_GvEw:          call    _Gv
                call    Comma
                jmp     _Ew

_GvEv:          call    _Gv
                call    Comma
                jmp     _M

_GvEvIv:        call    _Gv
                call    Comma
                call    _M
                jmp     Comma_Iv

_GvEvIb:        call    _Gv
                call    Comma
                call    _M
                jmp     Comma_Ib

_GvM:           call    _Gv
                jmp     Comma_M

_GvMa           equ     _GvM
_GvMp           equ     _GvM

Comma_Gw:       call    Comma
_Gw:            mov     al,dh
                shr     al,3
                jmp     _Rw

Comma_Ib:       call    Comma
_Ib:            lodsb
                jmp     HexByte


_Iw:            lodsw
                jmp     HexWord

_IwIb:          call    _Iw
                jmp     Comma_Ib

Comma_Iv:       call    Comma
_Iv:            call    TestOprSize
                jz      _Iv1
                lodsw
                xchg    ax,cx
                lodsw
                xchg    ax,cx
                jmp     HexDWord
_Iv1:           lodsw
                jmp     HexWord

_Jb:            lodsb
                cbw
                add     ax,si
                jmp     HexWord

_Jv:            lodsw
                add     ax,si
                jmp     HexWord

Comma_Ob:       call    Comma
_Ob:            mov     al,cs:SegOverride
                cmp     al,-1
                je      _Ob0
                call    _Rs
                mov     al,':'
                stosb
_Ob0:           mov     al,'['
                stosb
                call    TestAddrSize
                jz      _Ob1
                lodsw
                xchg    ax,cx
                lodsw
                xchg    ax,cx
                call    HexDWord
                jmp     _Ob2
_Ob1:           lodsw
                call    HexWord
_Ob2:           mov     al,']'
                stosb
                ret

_Obal:          call    _Ob
                jmp     Comma_al

Comma_Ov        equ     Comma_Ob
_Ov             equ     _Ob

_Ovax:          call    _Ov
                jmp     Comma_ax

_RbIb:          call    _Rb
                jmp     Comma_Ib

_RdCd:          call    _Rd
                jmp     Comma_Cd

_RdDd:          call    _Rd
                jmp     Comma_Dd

_RdTd:          call    _Rd
                jmp     Comma_Td

_RvIv:          call    _Rv
                jmp     Comma_Iv

_SrEw:          call    _Sr
                call    Comma
                mov     dl,1
                jmp     _M

Comma_Td:       call    Comma
_Td:            mov     ax,'RT'
                jmp     _Cd1

_TdRd:          call    _Td
                call    Comma
                jmp     _Rd

;==============================================================================
;
; Errr... The tables
;

Mnemonics       db      'PUSHF PUSHFDPOPF  POPFD CBW   CWDE  CWD   CDQ   '
                db      'INSW  INSD  OUTSW OUTSD MOVSW MOVSD CMPSW CMPSD '
                db      'STOSW STOSD LODSW LODSD SCASW SCASD ADD   PUSH  '
                db      'POP   OR    ADC   ARC   SBB   AND   AAA   SUB   '
                db      'AAS   XOR   CMP   INC   DEC   PUSHA POPA  BOUND '
                db      'ARPL  IMUL  INSB  OUTSB JO    JNO   JB    JAE   '
                db      'JZ    JNZ   JBE   JA    JS    JNS   JPE   JPO   '
                db      'JL    JGE   JLE   JG    TEST  XCHG  MOV   LEA   '
                db      'NOP   CALL  WAIT  SAHF  LAHF  MOVSB CMPSB STOSB '
                db      'LODSB SCASB RETN  LES   LDS   ENTER LEAVE RETF  '
                db      'INT   INTO  IRET  AAM   AAD   XLAT  ESC   LOOPNZ'
                db      'LOOPZ LOOP  JCXZ  IN    OUT   JMP   LOCK  REPNE '
                db      'REPE  HLT   CMC   CLC   STC   CLI   STI   CLD   '
                db      'STD   LAR   LSL   CLTS  SETO  SETNO SETB  SETAE '
                db      'SETZ  SETNZ SETBE SETA  SETS  SETNS SETPE SETPO '
                db      'SETL  SETGE SETLE SETG  BT    SHLD  BTS   SHRD  '
                db      'LSS   BTR   LFS   LGS   MOVZX BTC   BSF   BSR   '
                db      'MOVSX ROL   ROR   RCL   RCR   SHL   SHR   SAR   '
                db      'NOT   NEG   MUL   DIV   IDIV  SLDT  STR   LLDT  '
                db      'LTR   VERR  VERW  SGDT  SIDT  LGDT  LIDT  SMSW  '
                db      'LMSW  '

Opcodes1        db      016h,016h,016h,016h,016h,016h,017h,018h
                db      019h,019h,019h,019h,019h,019h,017h,0F0h
                db      01Ah,01Ah,01Ah,01Ah,01Ah,01Bh,017h,018h
                db      01Ch,01Ch,01Ch,01Ch,01Ch,01Ch,017h,018h
                db      01Dh,01Dh,01Dh,01Dh,01Dh,01Dh,0E8h,01Eh
                db      01Fh,01Fh,01Fh,01Fh,01Fh,01Fh,0E9h,020h
                db      021h,021h,021h,021h,021h,021h,0EAh,01Eh
                db      022h,022h,022h,022h,022h,022h,0EBh,020h
                db      023h,023h,023h,023h,023h,023h,023h,023h
                db      024h,024h,024h,024h,024h,024h,024h,024h
                db      017h,017h,017h,017h,017h,017h,017h,017h
                db      018h,018h,018h,018h,018h,018h,018h,018h
                db      025h,026h,027h,028h,0ECh,0EDh,0EFh,0EEh
                db      017h,029h,017h,029h,02Ah,008h,02Bh,00Ah
                db      02Ch,02Dh,02Eh,02Fh,030h,031h,032h,033h
                db      034h,035h,036h,037h,038h,039h,03Ah,03Bh
                db      0E0h,0E0h,0E0h,0E0h,03Ch,03Ch,03Dh,03Dh
                db      03Eh,03Eh,03Eh,03Eh,03Eh,03Fh,03Eh,018h
                db      040h,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh
                db      004h,006h,041h,042h,000h,002h,043h,044h
                db      03Eh,03Eh,03Eh,03Eh,045h,00Ch,046h,00Eh
                db      03Ch,03Ch,047h,010h,048h,012h,049h,014h
                db      03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh
                db      03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh
                db      0E1h,0E1h,04Ah,04Ah,04Bh,04Ch,03Eh,03Eh
                db      04Dh,04Eh,04Fh,04Fh,050h,050h,051h,052h
                db      0E1h,0E1h,0E1h,0E1h,053h,054h,0F1h,055h
                db      056h,056h,056h,056h,056h,056h,056h,056h
                db      057h,058h,059h,05Ah,05Bh,05Bh,05Ch,05Ch
                db      041h,05Dh,05Dh,05Dh,05Bh,05Bh,05Ch,05Ch
                db      05Eh,0F1h,05Fh,060h,061h,062h,0E2h,0E2h
                db      063h,064h,065h,066h,067h,068h,0E3h,0E4h

Operands1       dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _alIb,  _axIv,  _Rs18,  _Rs18
                dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _alIb,  _axIv,  _Rs18,  ___
                dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _alIb,  _axIv,  _Rs18,  _Rs18
                dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _alIb,  _axIv,  _Rs18,  _Rs18
                dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _alIb,  _axIv,  ___,    ___
                dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _alIb,  _axIv,  ___,    ___
                dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _alIb,  _axIv,  ___,    ___
                dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _alIb,  _axIv,  ___,    ___
                dw      _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv
                dw      _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv
                dw      _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv
                dw      _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv,    _Rv
                dw      ___,    ___,    _GvMa,  _EwGw,  ___,    ___,    ___,    ___
                dw      _Iv,    _GvEvIv,_Ib,    _GvEvIb,___,    ___,    ___,    ___
                dw      _Jb,    _Jb,    _Jb,    _Jb,    _Jb,    _Jb,    _Jb,    _Jb
                dw      _Jb,    _Jb,    _Jb,    _Jb,    _Jb,    _Jb,    _Jb,    _Jb
                dw      _EbIb,  _EvIv,  _EbIb,  _EvIb,  _EbGb,  _EvGv,  _EbGb,  _EvGv
                dw      _EbGb,  _EvGv,  _GbEb,  _GvEv,  _EwSr,  _GvM,   _SrEw,  _Ev
                dw      ___,    _axRv,  _axRv,  _axRv,  _axRv,  _axRv,  _axRv,  _axRv
                dw      ___,    ___,    _Ap,    ___,    ___,    ___,    ___,    ___
                dw      _alOb,  _axOv,  _Obal,  _Ovax,  ___,    ___,    ___,    ___
                dw      _alIb,  _axIv,  ___,    ___,    ___,    ___,    ___,    ___
                dw      _RbIb,  _RbIb,  _RbIb,  _RbIb,  _RbIb,  _RbIb,  _RbIb,  _RbIb
                dw      _RvIv,  _RvIv,  _RvIv,  _RvIv,  _RvIv,  _RvIv,  _RvIv,  _RvIv
                dw      _EbIb,  _EvIb,  _Iw,    ___,    _GvMp,  _GvMp,  _EbIb,  _EvIv
                dw      _IwIb,  ___,    _Iw,    ___,    _3,     _Ib,    ___,    ___
                dw      _Eb1,   _Ev1,   _Ebcl,  _Ebcl,  _Ib,    _Ib,    ___,    ___
                dw      _M,     _M,     _M,     _M,     _M,     _M,     _M,     _M
                dw      _Jb,    _Jb,    _Jb,    _Jb,    _alIb,  _axIb,  _Ibal,  _Ibax
                dw      _Jv,    _Jv,    _Ap,    _Jb,    _aldx,  _axdx,  _dxal,  _dxax
                dw      ___,    ___,    ___,    ___,    ___,    ___,    _G3Eb,  _G3Ev
                dw      ___,    ___,    ___,    ___,    ___,    ___,    _G4,    _G5

WordRegs        db      'AXCXDXBXSPBPSIDI'
ByteRegs        db      'ALCLDLBLAHCHDHBH'
SegRegs         db      'ESCSSSDSFSGS????'
FirstEAReg      db      'BXBXBPBPSIDIBPBX'
SecondEAReg     db      'SIDISIDI'

 
Opcodes2        db      0E5h,0E6h,069h,06Ah,0F1h,0F1h,06Bh,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      03Eh,03Eh,03Eh,03Eh,03Eh,0F1h,03Eh,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      02Ch,02Dh,02Eh,02Fh,030h,031h,032h,033h
                db      034h,035h,036h,037h,038h,039h,03Ah,03Bh
                db      06Ch,06Dh,06Eh,06Fh,070h,071h,072h,073h
                db      074h,075h,076h,077h,078h,079h,07Ah,07Bh
                db      017h,018h,0F1h,07Ch,07Dh,07Dh,0F1h,0F1h
                db      017h,018h,0F1h,07Eh,07Fh,07Fh,0F1h,029h
                db      0F1h,0F1h,080h,081h,082h,083h,084h,084h
                db      0F1h,0F1h,0E7h,085h,086h,087h,088h,088h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h

Operands2       dw      ___,    ___,    _GvEw,  _GvEw,  ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      _CdRd,  _DdRd,  _RdCd,  _RdDd,  _TdRd,  ___,    _RdTd,  ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      _Jv,    _Jv,    _Jv,    _Jv,    _Jv,    _Jv,    _Jv,    _Jv
                dw      _Jv,    _Jv,    _Jv,    _Jv,    _Jv,    _Jv,    _Jv,    _Jv
                dw      _Eb,    _Eb,    _Eb,    _Eb,    _Eb,    _Eb,    _Eb,    _Eb
                dw      _Eb,    _Eb,    _Eb,    _Eb,    _Eb,    _Eb,    _Eb,    _Eb
                dw      _fs,    _fs,    ___,    _EvGv,  _EvGvIb,_EvGvcl,___,    ___
                dw      _gs,    _gs,    ___,    _EvGv,  _EvGvIb,_EvGvcl,___,    _GvEv
                dw      ___,    ___,    _Mp,    _EvGv,  _Mp,    _Mp,    _GvEb,  _GvEw
                dw      ___,    ___,    _EvIb,  _EvGv,  _GvEv,  _GvEv,  _GvEb,  _GvEw
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___
                dw      ___,    ___,    ___,    ___,    ___,    ___,    ___,    ___

Opcodes3        db      016h,019h,01Ah,01Ch,01Dh,01Fh,021h,022h
                db      089h,08Ah,08Bh,08Ch,08Dh,08Eh,0F1h,08Fh
                db      03Ch,0F1h,090h,091h,092h,029h,093h,094h
                db      023h,024h,0F1h,0F1h,0F1h,0F1h,0F1h,0F1h
                db      023h,024h,041h,041h,05Dh,05Dh,017h,0F1h
                db      095h,096h,097h,098h,099h,09Ah,0F1h,0F1h
                db      09Bh,09Ch,09Dh,09Eh,09Fh,0F1h,0A0h,0F1h
                db      0F1h,0F1h,0F1h,0F1h,07Ch,07Eh,081h,085h

code ends

end
