.286

code segment public use16 'code'
                assume  cs:code, ds:code, ss:code

                public  Monitor

                ;
                ;       Externals from TRACER.ASM
                ;
                extrn   StartTrace: far, StartAtCSIP: near, SavedFlags: Word
                extrn   SavedIP: word, SavedAX: word, SavedBX: word
                extrn   SavedCX: word, SavedDX: word, SavedSP: word
                extrn   SavedBP: word, SavedSI: word, SavedDI: word
                extrn   SavedES: word, SavedCS: word, SavedSS: word,
                extrn   SavedDS: word, SavedCSIP: dword, SavedSSSP: dword
                extrn   TraceStack: near, CodeSegment: Word

                ;
                ;       Externals from DISASM.ASM
                ;
                extrn   Disassemble: near

                ;
                ;       Externals from IO.ASM
                ;
                extrn   PrintString: near, PrintChar: Near, PrintCrLf: near
                extrn   KeyPressed: near, ReadKey: near, FlushBuffer: near
                extrn   InitSerial: near

HistSize        equ     200h

_Ofs            equ     word ptr [0]
_Seg            equ     word ptr [2]

Main:           call    InitSerial      ; Set COM2 to 19200, 8N1
                call    InitInt6        ; Initialize "Invalid Opcode" int.
                call    StartTrace      ; Start Tracer

                mov     ax,3100h        ; Terminate & Stay Resident
                mov     dx,800h         ; Keep 32K of memory
                int     21h             ; Do it

Action          dw      offset Input

Monitor:        push    cs
                pop     ds
                mov     bx,HistPtr
                inc     HistPtr
                and     bx,HistSize - 1
                shl     bx,2
                mov     ax,SavedIP
                mov     History[bx]._Ofs,ax
                mov     ax,SavedCS
                mov     History[bx]._Seg,ax
                jmp     Action

NewCount        dw      ?

NewCode:        mov     ax,SavedIP
                mov     dx,SavedCS
                cmp     dx,CodeSegment
                jb      Execute
                cmp     dx,0a000h
                jae     Execute
                mov     cx,HistSize - 1
                mov     si,HistPtr
ScanNext:       mov     bx,si
                and     bx,HistSize - 1
                shl     bx,2
                cmp     ax,word ptr History[bx]
                jne     ScanDif
                cmp     dx,word ptr History[bx+2]
                je      Execute
ScanDif:        inc     si
                loop    ScanNext
                dec     NewCount
                jz      BreakOut
                call    PrintStatus
                jmp     Execute

SkipBreakCheck: mov     Action,offset Execute
                jmp     short Execute

BreakPoint:     mov     cx,BreakCount1
                jcxz    SkipBreakCheck
                push    cs
                pop     es
                mov     ax,SavedIP
                mov     dx,SavedCS
                mov     si,offset BreakPoints
                cld
NextBrkPnt:     mov     di,si
                scasw
                jne     AddrDiffirent
                xchg    ax,dx
                scasw
                je      BreakOut
                xchg    ax,dx
AddrDiffirent:  add     si,4
                loop    NextBrkPnt
Execute:        call    KeyPressed
                jnz     Breakout
                mov     ax,SavedAX
                cmp     ax,4b00h
                jne     NotDosExec
                les     bx,SavedCSIP
                cmp     word ptr es:[bx],21cdh
                jne     NotDosExec
                mov     ExecFlag,-1
                jmp     short DontBreak
NotDosExec:     cmp     ExecFlag,0
                je      DontBreak
                mov     ax,SavedCS
                mov     dx,cs
                cmp     ax,dx
                jb      DontBreak
                cmp     ax,0a000h
                jae     DontBreak
                mov     ExecFlag,0
                jmp     short Breakout
DontBreak:      clc
                ret

ExecFlag        db      0

Breakout:       mov     cs:Action,offset Input
                mov     ax,cs:BreakCount2
                mov     cs:BreakCount1,ax
Input:     ;     sti
                mov     ax,cs:SavedIP
                mov     cs:DisasmAddr._Ofs,ax
                mov     cs:DumpAddr._Ofs,ax
                mov     ax,cs:SavedCS
                mov     cs:DisasmAddr._Seg,ax
                mov     cs:DumpAddr._Seg,ax
                call    FlushBuffer
                call    PrintStatus
Prompt:         mov     al,'-'
                call    PrintChar
AnotherKey:     call    ReadKey
                cmp     al,'R'
                je      _R
                cmp     al,'Q'
                je      _Q
                cmp     al,'G'
                je      _G
                cmp     al,'U'
                je      _U
                cmp     al,'D'
                je      _D
                cmp     al,'P'
                je      _P
                cmp     al,'T'
                je      _T
                cmp     al,'B'
                je      _B
                cmp     al,'H'
                je      _H
                cmp     al,'C'
                je      _C
                cmp     al,'N'
                je      _N
                jmp     AnotherKey

_R:             jmp     R_Command
_Q:             jmp     Q_Command
_G:             jmp     G_Command
_U:             jmp     U_Command
_D:             jmp     D_Command
_P:             jmp     P_Command
_T:             jmp     T_Command
_B:             jmp     B_Command
_H:             jmp     H_Command
_C:             jmp     C_Command
_N:             jmp     N_Command

N_Command:      call    PrintChar
                xor     ax,ax
                call    ReadAddress
                jc      N_1
                or      dx,dx
                jnz     N_1
                cmp     ax,1
                jb      N_1
                cmp     ax,100h
                jbe     N_2
N_1:            mov     ax,1
N_2:            mov     NewCount,ax
                mov     Action,offset NewCode
                clc
                ret

C_Command:      call    PrintChar
                call    PrintCrLf
                mov     BreakCount1,0
                mov     BreakCount2,0
                jmp     Prompt

R_Command:      call    PrintCrLf
                call    PrintStatus
                mov     ax,cs:SavedIP
                mov     cs:DisasmAddr._Ofs,ax
                mov     cs:DumpAddr._Ofs,ax
                mov     ax,cs:SavedCS
                mov     cs:DisasmAddr._Seg,ax
                mov     cs:DumpAddr._Seg,ax
                jmp     Prompt

Q_Command:      call    PrintChar
                call    PrintCrLf
                stc
                ret

G_Command:      call    PrintChar
                mov     ax,SavedCS
                call    ReadAddress
                jc      G_1
                mov     di,BreakCount1
                cmp     di,MaxBreakPoint
                jae     G_1
                inc     BreakCount1
                shl     di,2
                mov     word ptr BreakPoints[di],ax
                mov     word ptr BreakPoints[di+2],dx
G_1:            mov     Action,offset BreakPoint
                clc
                ret

U_Command:      call    PrintChar
                mov     ax,SavedCS
                call    ReadAddress
                jc      U_1
                mov     DisasmAddr._Ofs,ax
                mov     DisasmAddr._Seg,dx
U_1:            mov     cx,10
                lds     si,DisasmAddr
U_2:            push    cx
                call    PrintDisasm
                pop     cx
                loop    U_2
                push    cs
                pop     ds
                mov     DisasmAddr._Ofs,si
                jmp     Prompt

D_Command:      call    PrintChar
                mov     ax,SavedDS
                call    ReadAddress
                jc      D_1
                mov     DumpAddr._Ofs,ax
                mov     DumpAddr._Seg,dx
D_1:            mov     cx,8
                lds     si,DumpAddr
D_2:            push    cx
                call    PrintDump
                pop     cx
                loop    D_2
                push    cs
                pop     ds
                mov     DumpAddr._Ofs,si
                jmp     Prompt

P_Command:      push    ax
                les     bx,SavedCSIP
                mov     al,es:[bx]
                cmp     al,0cdh
                je      TwoBytes
                cmp     al,0e8h
                je      ThreeBytes
                jmp     CantProceed
ThreeBytes:     inc     bx
TwoBytes:       inc     bx
                inc     bx
                mov     di,BreakCount1
                cmp     di,MaxBreakPoint
                jae     CantProceed
                inc     BreakCount1
                shl     di,2
                mov     word ptr BreakPoints[di],bx
                mov     word ptr BreakPoints[di+2],es
                mov     Action,offset BreakPoint
CantProceed:    pop     ax
T_Command:      call    PrintChar
                call    PrintCrLf
                clc
                ret

B_Command:      call    PrintChar
                cmp     BreakCount1,MaxBreakPoint
                jae     B_1
                mov     ax,SavedCS
                call    ReadAddress
                jc      B_1
                mov     di,BreakCount1
                inc     BreakCount1
                inc     BreakCount2
                shl     di,2
                mov     word ptr BreakPoints[di],ax
                mov     word ptr BreakPoints[di+2],dx
B_1:            push    cs
                pop     es
                xor     ax,ax
                mov     cx,BreakCount1
                jcxz    B_3
                mov     si,offset BreakPoints
B_2:            push    ax
                push    cx
                push    si
                mov     di,offset BreakString + 6
                call    HexByte
                add     di,3
                mov     ax,ds:[si+2]
                call    HexWord
                inc     di
                mov     ax,ds:[si]
                call    HexWord
                mov     si,offset BreakString
                call    PrintString
                pop     si
                pop     cx
                pop     ax
                inc     ax
                add     si,4
                loop    B_2
B_3:            jmp     Prompt

H_Command:      call    PrintChar
                call    PrintCrLf
                mov     cx,HistSize
H_1:            push    cx
                mov     bx,HistPtr
                inc     HistPtr
                and     bx,HistSize - 1
                shl     bx,2
                lds     si,History[bx]
                call    PrintDisasm
                push    cs
                pop     ds
                pop     cx
                loop    H_1
                jmp     Prompt

HistPtr         dw      ?
History         dd      HistSize dup(?)

DisasmAddr      dd      ?
DumpAddr        dd      ?

BreakString     db      'BREAK 00 = 0000:0000',13,10,0

;==============================================================================

InputBuffer     db      51h dup(0)
AddressOfs      dw      ?
AddressSeg      dw      ?

ReadAddress:    mov     AddressOfs,0
                mov     AddressSeg,ax
                mov     al,' '
                call    PrintChar
                xor     bx,bx
                xor     cx,cx
Address_1:      call    ReadKey
                cmp     al,8
                jne     Address_2
                or      bx,bx
                jz      Address_1
                dec     bx
                mov     InputBuffer[bx],0
                call    PrintChar
                mov     al,' '
                call    PrintChar
                mov     al,8
                call    PrintChar
                jmp     Address_1
Address_2:      cmp     al,13
                je      Address_3
                cmp     al,20h
                jbe     Address_1
                cmp     al,7fh
                jae     Address_1
                cmp     bx,50h
                jae     Address_1
                mov     InputBuffer[bx],al
                inc     bx
                mov     InputBuffer[bx],0
                call    PrintChar
                jmp     Address_1
Address_3:      cmp     al,13
                jne     Address_1
                or      bx,bx
                jz      Address_8
                push    bx
                push    AddressSeg
                push    AddressOfs
                xor     bx,bx
Address_4:      call    ReadWord
                jc      Address_7
                add     AddressOfs,ax
                mov     al,InputBuffer[bx]
                inc     bx
                cmp     al,'+'
                je      Address_4
                cmp     al,':'
                jne     Address_6
                xor     ax,ax
                xchg    ax,AddressOfs
                mov     AddressSeg,ax
Address_5:      call    ReadWord
                jc      Address_7
                add     AddressOfs,ax
                mov     al,InputBuffer[bx]
                inc     bx
                cmp     al,'+'
                je      Address_5
Address_6:      add     al,-1
Address_7:      mov     ax,AddressOfs
                mov     dx,AddressSeg
                pop     AddressOfs
                pop     AddressSeg
                pop     bx
                jnc     Address_8
                jmp     Address_1
Address_8:      push    ax
                push    dx
                call    PrintCrLf
                pop     dx
                pop     ax
                cmp     bx,1
                ret

ReadWord:       mov     ax,word ptr InputBuffer[bx]
                add     bx,2
                cmp     ax,"XA"
                jne     Read_AX
                mov     ax,SavedAX
                ret
Read_AX:        cmp     ax,"XB"
                jne     Read_BX
                mov     ax,SavedBX
                ret
Read_BX:        cmp     ax,"XC"
                jne     Read_CX
                mov     ax,SavedCX
                ret
Read_CX:        cmp     ax,"XD"
                jne     Read_DX
                mov     ax,SavedDX
                ret
Read_DX:        cmp     ax,"PS"
                jne     Read_SP
                mov     ax,SavedSP
                ret
Read_SP:        cmp     ax,"PB"
                jne     Read_BP
                mov     ax,SavedBP
                ret
Read_BP:        cmp     ax,"IS"
                jne     Read_SI
                mov     ax,SavedSI
                ret
Read_SI:        cmp     ax,"ID"
                jne     Read_DI
                mov     ax,SavedDI
                ret
Read_DI:        cmp     ax,"PI"
                jne     Read_IP
                mov     ax,SavedIP
                ret
Read_IP:        cmp     ax,"SD"
                jne     Read_DS
                mov     ax,SavedDS
                ret
Read_DS:        cmp     ax,"SE"
                jne     Read_ES
                mov     ax,SavedES
                ret
Read_ES:        cmp     ax,"SS"
                jne     Read_SS
                mov     ax,SavedSS
                ret
Read_SS:        cmp     ax,"SC"
                jne     Read_CS
                mov     ax,SavedCS
                ret
Read_CS:        dec     bx
                mov     cx,bx
                dec     bx
                xor     ax,ax
Read_1:         mov     dx,ax
                test    dh,0f0h
                jnz     Read_3
                mov     al,InputBuffer[bx]
                sub     al,'0'
                jb      Read_3
                cmp     al,9
                jbe     Read_2
                sub     al,7
                cmp     al,9
                jbe     Read_3
                cmp     al,15
                ja      Read_3
Read_2:         inc     bx
                cbw
                shl     dx,4
                add     ax,dx
                jmp     Read_1
Read_3:         xchg    ax,dx
                cmp     bx,cx
                ret

MaxBreakPoint   equ     10
BreakCount1     dw      0
BreakCount2     dw      0
BreakPoints     dd      MaxBreakPoint dup(?)

;==============================================================================
;
; Print Status
;

StatusMsg       db      'AX=0000  BX=0000  CX=0000  DX=0000  SP=0000  BP=0000  SI=0000  DI=0000',13,10
                db      'DS=0000  ES=0000  SS=0000  CS=0000  IP=0000  FLAGS=O D I T S Z A P C ',13,10,0
DisasmMsg       db      '0000:0000 ',70 dup(?),13,10,0
DumpMsg         db      '0000:0000 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00 00 ................',13,10,0

RegPointers     dw      SavedAX, SavedBX, SavedCX, SavedDX, SavedSP, SavedBP, SavedSI, SavedDI
                dw      SavedDS, SavedES, SavedSS, SavedCS, SavedIP

FlagMasks       dw      800h,'oO',400h,'dD',200h,'iI',100h,'tT'
                dw      080h,'sS',040h,'zZ',010h,'aA',004h,'pP',001h,'cC'

PrintStatus:    push    cs
                pop     es
                mov     cx,13
                mov     si,offset RegPointers
                mov     di,offset StatusMsg + 3
                cld
PrintNxtReg:    lodsw
                xchg    ax,bx
                mov     ax,ds:[bx]
                call    HexWord
                add     di,5
                loop    PrintNxtReg
                mov     cx,9
                mov     si,offset FlagMasks
                add     di,3
                mov     dx,SavedFlags
PrintNxtFlag:   lodsw
                test    dx,ax
                lodsw
                jnz     FlagSet
                xchg    al,ah
FlagSet:        mov     ah,' '
                stosw
                loop    PrintNxtFlag
                mov     si,offset StatusMsg
                call    PrintString
                lds     si,SavedCSIP
                call    PrintDisasm
                push    cs
                pop     ds
                ret

PrintDisasm:    push    cs
                pop     es
                mov     di,offset DisasmMsg
                cld
                mov     ax,ds
                call    HexWord
                inc     di
                mov     ax,si
                call    HexWord
                inc     di
                push    di
                mov     ax,'  '
                mov     cx,10
                rep     stosw
                call    Disassemble
                push    cx
                mov     al,0
                mov     cx,-1
                repne   scasb
                dec     di
                mov     al,13
                mov     ah,10
                stosw
                mov     al,0
                stosb
                pop     cx
                pop     di
                cmp     cx,10
                jcxz    ZeroBytes
                jbe     PrintNxtByte
                mov     cx,10
PrintNxtByte:   lodsb
                call    HexByte
                loop    PrintNxtByte
ZeroBytes:      push    ds
                push    si
                push    cs
                pop     ds
                mov     si,offset DisasmMsg
                call    PrintString
                pop     si
                pop     ds
                ret

PrintDump:      push    cs
                pop     es
                mov     di,offset DumpMsg
                mov     ax,ds
                call    HexWord
                inc     di
                mov     ax,si
                call    HexWord
                inc     di
                mov     cx,10h
DumpByte:       lodsb
                call    HexByte
                inc     di
                loop    DumpByte
                mov     cx,10h
                sub     si,cx
DumpChar:       lodsb
                cmp     al,20h
                jb      DumpDot
                cmp     al,7fh
                jb      DumpIt
DumpDot:        mov     al,'.'
DumpIt:         stosb
                loop    DumpChar
                push    ds
                push    si
                push    cs
                pop     ds
                mov     si,offset DumpMsg
                call    PrintString
                pop     si
                pop     ds
                ret

HexWord:        push    ax
                mov     al,ah
                call    HexByte
                pop     ax
HexByte:        push    ax
                shr     al,4
                call    HexDigit
                pop     ax
                and     al,0fh
HexDigit:       add     al,'0'
                cmp     al,'9'
                jbe     DigitOK
                add     al,7
DigitOK:        stosb
                ret

;==============================================================================
;
; Initialize routines
;

InitInt6:       cli
                xor     ax,ax
                mov     ds,ax
                mov     ax,offset InvalidOpcode
                mov     ds:[18h],ax
                mov     ds:[1ah],cs
                sti
                ret

;==============================================================================
;
; Exeption handling
;

InvalidMsg      db      'Invalid opcode (0000:0000)',13,10,0
InvalidAddr     dd      ?

InvalidOpcode:  pop     cs:InvalidAddr._Ofs
                pop     cs:InvalidAddr._Seg
                pop     cs:SavedFlags
                mov     cs:SavedSS,ss
                mov     cs:SavedSP,sp
                mov     ss,cs:CodeSegment
                mov     sp,offset TraceStack
                and     cs:SavedFlags,not 100h
                mov     cs:Action,offset Input
                push    cs:SavedFlags
                pusha
                push    ds
                push    es
                push    cs
                pop     ds
                push    cs
                pop     es
                mov     di,offset InvalidMsg + 16
                mov     ax,InvalidAddr._Seg
                call    HexWord
                inc     di
                mov     ax,InvalidAddr._Ofs
                call    HexWord
                mov     si,offset InvalidMsg
                call    PrintString
                pop     es
                pop     ds
                popa
                popf
                mov     ss,cs:SavedSS
                mov     sp,cs:SavedSP
                jmp     StartAtCSIP

code ends

end Main
