.286

;
; One way to detect this tracer: "MOV  CS,AX" works!!!!
;

code segment public use16 'code'
                assume  cs:code, ds:code, ss:code

                public  StartTrace, StartAtCSIP, SavedFlags, TraceStack
                public  SavedIP, SavedAX, SavedBX, SavedCX, SavedDX
                public  SavedSP, SavedBP, SavedSI, SavedDI, SavedES
                public  SavedCS, SavedSS, SavedDS, SavedCSIP, SavedSSSP
                public  CodeSegment

                extrn   Monitor: near

;==============================================================================
;
; Constants
;

bpSavedES       equ     word  ptr [bp + SavedES       - BasePtr]
bpSavedDS       equ     word  ptr [bp + SavedDS       - BasePtr]
bpSavedDI       equ     word  ptr [bp + SavedDI       - BasePtr]
bpSavedSI       equ     word  ptr [bp + SavedSI       - BasePtr]
bpSavedBP       equ     word  ptr [bp + SavedBP       - BasePtr]
bpSavedSP       equ     word  ptr [bp + SavedSP       - BasePtr]
bpSavedBX       equ     word  ptr [bp + SavedBX       - BasePtr]
bpSavedDX       equ     word  ptr [bp + SavedDX       - BasePtr]
bpSavedCX       equ     word  ptr [bp + SavedCX       - BasePtr]
bpSavedAX       equ     word  ptr [bp + SavedAX       - BasePtr]
bpSavedFlags    equ     word  ptr [bp + SavedFlags    - BasePtr]

bpSavedCSIP     equ     dword ptr [bp + SavedCSIP     - BasePtr]
bpSavedIP       equ     word  ptr [bp + SavedIP       - BasePtr]
bpSavedCS       equ     word  ptr [bp + SavedCS       - BasePtr]

bpSavedSSSP     equ     dword ptr [bp + SavedSSSP     - BasePtr]
bpSavedSP       equ     word  ptr [bp + SavedSP       - BasePtr]
bpSavedSS       equ     word  ptr [bp + SavedSS       - BasePtr]
bpSavedDS       equ     word  ptr [bp + SavedDS       - BasePtr]

bpStartOpcode   equ     word  ptr [bp + StartOpcode   - BasePtr]
bpExceptionIP   equ     word  ptr [bp + ExceptionIP   - BasePtr]
bpSegIndex      equ     word  ptr [bp + SegIndex      - BasePtr]
bpInterrupt     equ     word  ptr [bp + Interrupt     - BasePtr]
bpIntXX_IP      equ     word  ptr [bp + IntXX_IP      - BasePtr]
bpIntXX_CS      equ     word  ptr [bp + IntXX_CS      - BasePtr]
bpUpdateSeg     equ     word  ptr [bp + UpdateSeg     - BasePtr]
bpOverrideOfs   equ     word  ptr [bp + OverrideOfs   - BasePtr]
bpCounter       equ     byte  ptr [bp + Counter       - BasePtr]
bpSegOverride   equ     byte  ptr [bp + SegOverride   - BasePtr]
bpTraceFlags    equ     byte  ptr [bp + TraceFlags    - BasePtr]
bpDebugFlag     equ     byte  ptr [bp + DebugFlag     - BasePtr]

flgUsesES       equ     01h
flgUsesCS       equ     02h
flgUsesOther    equ     04h
flgUsesDS       equ     08h
flgAddressSize  equ     10h
flgOperandSize  equ     20h
flgIntHooked    equ     40h
flgDontCallInt1 equ     80h

;==============================================================================
;
; The tables this tunneler can't work without
;
; The JumpTable is an array of 32 words
;

_01             equ     OneByte         - StartTracerCode
_04             equ     FourBytes       - StartTracerCode
_XX             equ     Invalid         - StartTracerCode
_G3             equ     Group3          - StartTracerCode
_G5             equ     Group5          - StartTracerCode
_2B             equ     TwoByteEscape   - StartTracerCode
_AS             equ     AddressSize     - StartTracerCode ; Address Size
_OS             equ     OperandSize     - StartTracerCode ; Operand Size
_PR             equ     Opcode          - StartTracerCode ; Opcode
_O0             equ     OverrideES      - StartTracerCode ; ES:
_O1             equ     OverrideCS      - StartTracerCode ; CS:
_O2             equ     OverrideOther   - StartTracerCode ; SS:
_O3             equ     OverrideDS      - StartTracerCode ; DS:
_O4             equ     OverrideOther   - StartTracerCode ; FS:
_O5             equ     OverrideOther   - StartTracerCode ; GS:
_MS             equ     MovSeg          - StartTracerCode ; mov   r/m,seg
_SM             equ     MovSeg          - StartTracerCode ; mov   seg,r/m
_RM             equ     Memory          - StartTracerCode ; ???   r/m,???
_IB             equ     ByteImm         - StartTracerCode
_MB             equ     MemByteImm      - StartTracerCode
_IW             equ     WordImm         - StartTracerCode
_MW             equ     MemWordImm      - StartTracerCode
_OI             equ     ImmOffset       - StartTracerCode
_1X             equ     UsesES          - StartTracerCode ; movs, cmps
_1D             equ     Return          - StartTracerCode ; outs, lods, xlat
_1E             equ     UsesES          - StartTracerCode ; ins, stos, scas
_U0             equ     UsesES          - StartTracerCode ; push/pop es
_U1             equ     UsesCS          - StartTracerCode ; push     cs
_U2             equ     UsesOther       - StartTracerCode ; push     ss
_U3             equ     UsesDS          - StartTracerCode ; push/pop ds
_C2             equ     PopSS           - StartTracerCode ; pop      ss
_JS             equ     JumpShort       - StartTracerCode
_JN             equ     JumpNear        - StartTracerCode
_JF             equ     JumpFar         - StartTracerCode
_CN             equ     CallNear        - StartTracerCode
_CF             equ     CallFar         - StartTracerCode
_AM             equ     TrapAAM         - StartTracerCode
_TB             equ     TrapBound       - StartTracerCode
_IO             equ     IntoCall        - StartTracerCode
_I3             equ     Int3Call        - StartTracerCode
_II             equ     IntCall         - StartTracerCode
_IR             equ     IntReturn       - StartTracerCode
_RI             equ     ReturnImm       - StartTracerCode
_R0             equ     Return_0        - StartTracerCode
_FL             equ     PushfPopf       - StartTracerCode
_LD             equ     LoadDS          - StartTracerCode
_LE             equ     LoadES          - StartTracerCode

                ;        0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
                ;
OpcodeTable     db      _RM,_RM,_RM,_RM,_IB,_IW,_U0,_U0,_RM,_RM,_RM,_RM,_IB,_IW,_U1,_2B ; 0
                db      _RM,_RM,_RM,_RM,_IB,_IW,_U2,_C2,_RM,_RM,_RM,_RM,_IB,_IW,_U3,_U3 ; 1
                db      _RM,_RM,_RM,_RM,_IB,_IW,_O0,_01,_RM,_RM,_RM,_RM,_IB,_IW,_O1,_01 ; 2
                db      _RM,_RM,_RM,_RM,_IB,_IW,_O2,_01,_RM,_RM,_RM,_RM,_IB,_IW,_O2,_01 ; 3
                db      _01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01 ; 4
                db      _01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_01 ; 5
                db      _01,_01,_TB,_XX,_O4,_O5,_OS,_AS,_IW,_MW,_IB,_MB,_1D,_1D,_1E,_1E ; 6
                db      _JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS,_JS ; 7
                db      _MB,_MW,_MB,_MB,_RM,_RM,_RM,_RM,_RM,_RM,_RM,_RM,_MS,_RM,_SM,_RM ; 8
                db      _01,_01,_01,_01,_01,_01,_01,_01,_01,_01,_CF,_01,_FL,_FL,_01,_01 ; 9
                db      _OI,_OI,_OI,_OI,_1X,_1X,_1X,_1X,_IB,_IW,_1E,_1E,_1D,_1D,_1E,_1E ; A
                db      _IB,_IB,_IB,_IB,_IB,_IB,_IB,_IB,_IW,_IW,_IW,_IW,_IW,_IW,_IW,_IW ; B
                db      _MB,_MB,_RI,_R0,_LE,_LD,_MB,_MW,_04,_01,_RI,_R0,_I3,_II,_IO,_IR ; C
                db      _RM,_RM,_RM,_RM,_AM,_IB,_XX,_1D,_RM,_RM,_RM,_RM,_RM,_RM,_RM,_RM ; D
                db      _JS,_JS,_JS,_JS,_IB,_IB,_IB,_IB,_CN,_JN,_JF,_JS,_01,_01,_01,_01 ; E
                db      _PR,_XX,_PR,_PR,_01,_01,_G3,_G3,_01,_01,_01,_01,_01,_01,_RM,_G5 ; F

;==========================================================================================
;
; Tunnel code
;

StartTracerCode equ     $

FourBytes:      movsw
                movsb
                ret

CallNear:       push    si
                mov     ax,2
                call    Call_0
                pop     si
JumpNear:       lodsw
                add     si,ax
                jmp     ClearOpcode

CallFar:        push    si
                mov     ax,4
                call    Call_0
                pop     si
JumpFar:        lds     si,ds:[si]
                jmp     ClearOpcode

IntReturn:      call    Ret_1
PushfPopf:      jmp     Flags_0

AddressSize:    mov     al,66h xor flgOperandSize xor flgAddressSize
OperandSize:    xor     al,66h xor flgOperandSize
                dec     di
                test    al,bpTraceFlags
                jnz     Opcode
OrTraceFlag:    or      bpTraceFlags,al         ; 386-Opcode size
                inc     di
Opcode:         lodsb
                stosb
                mov     ah,0
                mov     bx,ax
                mov     bl,cs:OpcodeTable[bx]
                add     bx,offset StartTracerCode
                push    bx
                xor     cx,cx
                xor     bx,bx
Return:         ret

OverrideDS:     inc     cx
OverrideOther:  inc     cx
OverrideCS:     inc     cx
OverrideES:     xchg    cl,bpSegOverride
                lea     bx,[di-1]
                or      cl,cl
                js      FirstOverride
                mov     bx,bpOverrideOfs
                mov     es:[bx],al
                dec     di
FirstOverride:  mov     bpOverrideOfs,bx
                jmp     short Opcode

PopSS:          push    offset ChangesSS
                jmp     short UsesOther

LoadES:         push    offset Memory
                jmp     short UsesES

LoadDS:         push    offset Memory
UsesDS:         inc     cx
UsesOther:      inc     cx
UsesCS:         inc     cx
UsesES:         dec     bx
StoreSegInfo:   mov     ch,1
                cmp     cl,ch
                jne     NotCodeSeg
                add     bx,di
                mov     bpUpdateSeg,bx
NotCodeSeg:     shl     ch,cl
                or      bpTraceFlags,ch
                ret

IntCall:        jmp     Int_1

Int3Call:       mov     bl,3    ; mov   bx,3
                jmp     Int_2

IntoCall:       mov     bl,4    ; mov   bx,4
                jmp     Int_2

TrapBound:      mov     bl,5    ; mov   bx,5
Trap:           call    Memory
Exeption:       mov     cx,offset HookedExeption
                jmp     HookInt

TrapAAM:        movsb
                jmp     short Exeption

MovSeg:         mov     ah,al
                mov     al,ds:[si]
                and     al,38h
                cmp     ax,8e10h
                jne     Seg_1
                push    offset ChangesSS
Seg_1:          shr     al,3
                cmp     al,4
                jae     Memory
                xchg    ax,cx
                call    StoreSegInfo
Memory:         lodsb
                jmp     Mem_0

Group3:         test    byte ptr ds:[si],30h
                jpo     Memory
                jnz     Trap
                test    al,1
                jz      MemByteImm
MemWordImm:     call    Memory
WordImm:        mov     cl,flgOperandSize
Imm_1:          movsw
                test    cl,bpTraceFlags
                jz      Imm_2
                movsw
Imm_2:          ret

ImmOffset:      mov     cl,flgAddressSize
                jmp     short Imm_1

MemByteImm:     call    Memory
ByteImm:        movsb
OneByte:        ret

Group5:         mov     al,ds:[si]
                test    al,30h
                jpe     Memory
                and     al,38h
                cmp     al,20h
                je      IndJumpNear
                ja      IndJumpFar
                cmp     al,10h
                je      IndCallNear
                jmp     short IndCallFar

Invalid:        sti
                call    Monitor
                jmp     Invalid

JumpShort:      lodsb
                cbw
                jmp     Cond_1

ReturnImm:      mov     cx,ds:[si]
Return_0:       jmp     short Ret_1

TwoByteEscape:  lodsb
                stosb
                cmp     al,4
                jb      Memory
                cmp     al,22
                je      Memory
                cmp     al,80h
                jb      Invalid
                cmp     al,90h
                jb      CondJumpNear
                cmp     al,0a0h
                jb      Memory
                cmp     al,0afh
                jb      Opcode_2
                je      Memory
                cmp     al,0c0h
                jae     Invalid
Opcode_1:       test    al,06h
                jz      Invalid
                cmp     al,0bah
                je      JmpMemByteImm
                jmp     short Memory
Opcode_2:       test    al,06h
                jz      OneByte
                jpe     Invalid
                test    al,01h
                jnz     Memory
                test    al,03h
                jnz     Invalid
JmpMemByteImm:  jmp     MemByteImm

;==============================================================================

Ret_1:          mov     bx,ds
                lds     si,bpSavedSSSP
                test    al,8
                lodsw
                xchg    ax,bx
                jz      Ret_2
                lodsw
Ret_2:          add     si,cx
                mov     bpSavedSP,si
                mov     ds,ax
                mov     si,bx
                xor     ax,ax
ClearOpcode:    mov     di,bpStartOpcode
                ret

IndCallNear:    mov     cl,2
IndJumpNear:    mov     al,8bh
                jmp     short IndJump

IndCallFar:     mov     cl,4
IndJumpFar:     xor     ax,ax
                cmp     al,bpSegOverride
                sbb     al,-0c5h
IndJump:        dec     di
                stosb
                lodsb
                and     al,0c7h
                call    Mem_0
                jcxz    NoReturn
                xchg    ax,cx
                call    Call_1
NoReturn:       mov     dx,offset SetNewIP - 2
                mov     si,bpSavedAX
                or      bpTraceFlags,flgUsesCS
                ret

CondJumpNear:   sub     al,10h
                dec     di
                dec     di
                stosb
                lodsw
Cond_1:         xchg    ax,bx
                mov     ax,0e903h
                stosw
                mov     ax,dx
                sub     ax,di
                stosw
                mov     al,02eh
                stosb
                mov     ax,6c7h
                stosw
                mov     ax,offset SavedIP
                stosw
                lea     ax,[bx+si]
                stosw
                ret

Flags_0:        push    ds
                lds     bx,bpSavedSSSP
                cmp     al,9ch
                jne     Flags_1
                dec     bx
                dec     bx
                mov     ax,bpSavedFlags
                or      ah,bpDebugFlag
                mov     ds:[bx],ax
                jmp     short Flags_2
Flags_1:        mov     ax,ds:[bx]
                and     ax,100h
                mov     bpDebugFlag,ah
                xor     ax,ds:[bx]
                mov     bpSavedFlags,ax
                inc     bx
                inc     bx
Flags_2:        mov     bpSavedSP,bx
                pop     ds
                jmp     short ClearOpcode

Call_0:         add     si,ax
Call_1:         push    es
                push    di
                sub     bpSavedSP,ax
                les     di,bpSavedSSSP
                cmp     al,4
                mov     ax,si
                stosw
                jb      Call_2
                mov     ax,ds
                stosw
                je      Call_2
                mov     ax,bpSavedFlags
                or      ah,1
                stosw
Call_2:         pop     di
                pop     es
                ret

Mem_0:          stosb
                cmp     al,0c0h
                jae     Mem_5
                test    bpTraceFlags,flgAddressSize
                jz      Mem_1
                mov     ah,al
                xor     ax,403h
                test    ah,7
                jnz     Mem_1
                lodsb
                stosb
                xor     al,3
                and     ax,0c007h
                or      al,ah
Mem_1:          test    al,0c0h
                js      Mem_2
                jnz     Mem_4
                and     al,0c7h
                cmp     al,006h
                jne     Mem_5
Mem_2:          test    bpTraceFlags,flgAddressSize
                jz      Mem_3
                movsw
Mem_3:          movsb
Mem_4:          movsb
Mem_5:          ret

Int_1:          lodsb
                stosb
                mov     bl,al
Int_2:          mov     cx,offset HookedIntrpt
HookInt:        push    ds
                xor     ax,ax
                mov     ds,ax
                rol     bx,2
                mov     bpInterrupt,bx
                xchg    cx,ds:[bx]
                mov     bpIntXX_IP,cx
                mov     cx,cs
                xchg    cx,ds:[bx+2]
                mov     bpIntXX_CS,cx
                or      bpTraceFlags,flgIntHooked
                pop     ds
                ret

ChangesSS:      mov     ax,8300h
                cmp     al,bpCounter
                jne     SS_2
                inc     bpCounter
                push    si
                push    di
                push    bpOverrideOfs
                xchg    al,bpTraceFlags
                xchg    ah,bpSegOverride
                push    ax
                mov     bpStartOpcode,di
                call    Opcode
                pop     ax
                push    ax
                or      bpTraceFlags,al
                call    UpdateCS
                pop     ax
                pop     bpOverrideOfs
                mov     bpSegOverride,ah
                mov     bpUpdateSeg,0
                jnc     SS_1
                add     sp,4
                ret
SS_1:           mov     bpTraceFlags,al
                pop     di
                pop     si
SS_2:           ret

Instruction:    mov     bpExceptionIP,si
                call    Opcode
UpdateCS:       mov     ax,100h
                mov     cl,bpSegOverride
                and     cl,3
                shl     ah,cl
                or      ah,bpTraceFlags
                mov     bpTraceFlags,ah
                test    ah,flgUsesCS
                jz      CS_4
                mov     al,-8
                xor     bx,bx           ; mov  di,(SavedES - BasePtr)
                test    ah,flgUsesES
                jz      CS_1
                mov     al,10h
                inc     bx
                inc     bx              ; mov  di,(SavedDS - BasePtr)
                test    ah,flgUsesDS
                jnz     CS_5
CS_1:           push    bx
                mov     bx,bpUpdateSeg
                or      bx,bx
                jz      CS_2
                add     cs:[bx],al
CS_2:           cmp     cl,1
                jne     CS_3
                mov     bx,bpOverrideOfs
                add     cs:[bx],al
CS_3:           pop     bx
CS_4:           stc
CS_5:           ret

;==============================================================================

HookedIntrpt:   xchg    ax,cs:SavedIP
                mov     cs:ExceptionIP,ax
                jmp     short Hooked

HookedExeption: mov     cs:SavedIP,ax
Hooked:         pop     ax
                pop     ax
                pop     ax
                pushf
                and     ah,not 1
                or      cs:TraceFlags,flgDontCallInt1
                or      ah,cs:DebugFlag
                mov     cs:DebugFlag,0
                popf
                push    ax
                mov     ax,cs:IntXX_CS
                xchg    ax,cs:SavedCS
                push    ax
                push    cs:ExceptionIP
                mov     ax,cs:IntXX_IP
SetNewIP:       xchg    ax,cs:SavedIP
                jmp     short Tracer

;==============================================================================
;
; The main tracer procedure, to start tracing use a far call to the tracer. It
; will start tracing at the return address and stop when Monitor returns
; C-flag = 1.
;

CodeSegment     dw      0

StartTrace      label   far
                pop     cs:SavedIP
                pop     cs:SavedCS
StartAtCSIP:    mov     cs:DebugFlag,0
                mov     cs:TraceFlags,flgDontCallInt1
                mov     cs:CodeSegment,cs
Tracer:         mov     cs:SavedSS,ss
                mov     cs:SavedSP,sp
                mov     ss,cs:CodeSegment
                mov     sp,offset TraceStack
                pushf
                pusha
                push    ds
                push    es
                mov     bp,sp
                mov     ah,bpDebugFlag
                mov     al,0
                or      bpSavedFlags,ax
                mov     al,bpTraceFlags
                test    al,flgUsesCS
                jz      SegmentsOK
                mov     di,bpSegIndex
                mov     cx,[bp+di]
                xchg    cx,bpSavedCS
                mov     [bp+di],cx
SegmentsOK:     test    al,flgIntHooked
                jz      InterruptsOK
                xor     ax,ax
                mov     ds,ax
                mov     bx,bpInterrupt
                mov     ax,bpIntXX_IP
                mov     ds:[bx],ax
                mov     ax,bpIntXX_CS
                mov     ds:[bx+2],ax
InterruptsOK:   call    Monitor
CarryOK:        mov     bpSegOverride,83h
                mov     bpUpdateSeg,0
                mov     dx,offset Tracer - 2
                lds     si,bpSavedCSIP
                push    cs
                pop     es
                mov     di,offset TheBuffer
                mov     bpStartOpcode,di
                cld
                jc      TraceEnd
CannotEnd:      mov     ax,flgDontCallInt1
                xchg    al,bpTraceFlags
                test    al,flgDontCallInt1
                jz      CallInt1
                cmp     ah,bpDebugFlag
                je      DontCallInt1
                mov     bpTraceFlags,ah
DontCallInt1:   mov     bpCounter,ah
                call    Instruction
                mov     cx,ds
                mov     bpSavedIP,si
                cmp     al,0
                jz      CodeNotUsed
                mov     bpSegIndex,bx
                mov     si,bx
                xchg    cx,[bp+si]
CodeNotUsed:    mov     bpSavedCS,cx
                mov     al,0e9h
                stosb
                xchg    ax,dx
                sub     ax,di
                stosw
RestoreRegs:    and     bpSavedFlags,not 100h
                mov     sp,bp
                pop     es
                pop     ds
                popa
                popf
                mov     ss,cs:SavedSS
                mov     sp,cs:SavedSP
                jmp     TheBuffer

CallInt1:       mov     bx,1
                mov     cx,offset HookedIntrpt
                call    HookInt
                mov     ax,1cdh
                stosw
                jmp     short RestoreRegs

TraceEnd:       cmp     bpDebugFlag,0
                jnz     CannotEnd
                mov     al,0eah
                stosb
                mov     ax,si
                stosw
                mov     ax,ds
                stosw
                jmp     short RestoreRegs

;==============================================================================
;
; Uninitialized Data
;

                even

DataSize        equ     (TraceData - BasePtr)
TheBuffer:      dw      (200h - DataSize) / 2 dup(?)

BasePtr         equ     $               ;       mov   bp,sp
SavedES         dw      ?               ;       push  es
SavedDS         dw      ?               ;       push  ds
SavedDI         dw      ?               ; \
SavedSI         dw      ?               ;  \
SavedBP         dw      ?               ;   \
                dw      ?               ;    \  pusha
SavedBX         dw      ?               ;    /
SavedDX         dw      ?               ;   /
SavedCX         dw      ?               ;  /
SavedAX         dw      ?               ; /
SavedFlags      dw      ?               ;       pushf
TraceStack      equ     $               ;       mov   sp,offset TraceStack

SavedCSIP       label   dword
SavedIP         dw      ?
SavedCS         dw      ?

SavedSSSP       label   dword
SavedSP         dw      ?
SavedSS         dw      ?

Interrupt       dw      ?
IntXX_IP        dw      ?
IntXX_CS        dw      ?

StartOpcode     dw      ?
ExceptionIP     dw      ?
SegIndex        dw      ?
UpdateSeg       dw      ?
OverrideOfs     dw      ?
Counter         db      ?
SegOverride     db      ?
TraceFlags      db      ?
DebugFlag       db      ?
TraceData       equ     $

code ends

end
